import { isNaN,findIndex,chunk,drop,camelCase,endsWith,pick,words } from 'lodash';
import  moment from 'moment';
import { openToast } from '../location/Notification';
import { showToast } from '../location/Toast';
// 图片引入
import Compatibility from '../assets/Compatibility.png';
import Compatibility2 from '../assets/Compatibility2.png';
import Dimensions from '../assets/Dimensions.png';
import Dimensions2 from '../assets/Dimensions2.png';
import Database from '../assets/Database.png';
import Database2 from '../assets/Database2.png';
import DateImg from '../assets/Date.png';
import DateImg2 from '../assets/Date2.png';
import Finance from '../assets/Finance.png';
import Finance2 from '../assets/Finance2.png';
import MessageImg from '../assets/Message.png';
import MessageImg2 from '../assets/Message2.png';
import Logic from '../assets/Logic.png';
import Logic2 from '../assets/Logic2.png';
import Find from '../assets/Find.png';
import Find2 from '../assets/Find2.png';
import MathImg from '../assets/Math.png';
import MathImg2 from '../assets/Math2.png';
import Statistics from '../assets/Statistics.png';
import Statistics2 from '../assets/Statistics2.png';
import TextImg from '../assets/Text.png';
import TextImg2 from '../assets/Text2.png';
import Project from '../assets/Project.png';
import Project2 from '../assets/Project2.png';
import Column from '../assets/Column.png';
import Column2 from '../assets/Column2.png';
import PieImg from '../assets/Pie.png';
import PieImg2 from '../assets/Pie2.png';
import Radar from '../assets/Radar.png';
import Radar2 from '../assets/Radar2.png';
import Bubble from '../assets/Bubble.png';
import Bubble2 from '../assets/Bubble2.png';
import Splashes from '../assets/Splashes.png';
import Splashes2 from '../assets/Splashes2.png';
import Dendrogram from '../assets/Dendrogram.png';
import Dendrogram2 from '../assets/Dendrogram2.png';
import Box from '../assets/Box.png';
import Box2 from '../assets/Box2.png';
import Rising from '../assets/Rising.png';
import Rising2 from '../assets/Rising2.png';
import Line from '../assets/Line.png';
import Line2 from '../assets/Line2.png';
import Straight from '../assets/Straight.png';
import Straight2 from '../assets/Straight2.png';
let isArray = Array.isArray
/**
 * 函数集
 */
const List = [
    {
        name:'兼容性函数', // 系列函数名称
        images: Compatibility,
        pitchImages: Compatibility2,
        children:[
            {
                name:'兼容合并数组', // 函数代表名
                funcName: '将传入2个数组进行合并,返回一个合并后数组', // 函数名字
                function: MERGEARRAY, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入合并数组', // 第一个参数代表含义
                    },
                    {
                        text:'传入合并数组', // 第二个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[23,98,78],// 传入函数中的值
                        text:'[23,98,78]', // 展示页面所用值
                    },
                    {
                        value:[32,51,79],// 传入函数中的值
                        text:'[32,51,79]', // 展示页面所用值
                    },
                ],
                
            },
            {
                name:'兼容拆分数组', // 函数代表名
                funcName: '将传入数组按照传入长度进行拆分,返回一个拆分后多维数组', // 函数名字
                function: SPLITARRAY, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入需要拆分数组', // 第一个参数代表含义
                    },
                    {
                        text:'传入拆分长度', // 第二个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[23,98,78,65,32,11,12],// 传入函数中的值
                        text:'[23,98,78,65,32,11,12]', // 展示页面所用值
                    },
                    {
                        value:2,// 传入函数中的值
                        text:'2', // 展示页面所用值
                    },
                ],
                
            },
            {
                name:'兼容切片数组', // 函数代表名
                funcName: '将传入数组按照传入长度进行切片,返回一个切片后数组', // 函数名字
                function: REMOVEARRAYDROP, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入需要切片数组', // 第一个参数代表含义
                    },
                    {
                        text:'传入切片长度', // 第二个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[23,98,78,65,32,11,12],// 传入函数中的值
                        text:'[23,98,78,65,32,11,12]', // 展示页面所用值
                    },
                    {
                        value:2,// 传入函数中的值
                        text:'2', // 展示页面所用值
                    },
                ],
                
            },
        ]
    },
    {
        name:'多维数据集函数', // 系列函数名称
        images: Dimensions,
        pitchImages: Dimensions2,
        children:[
            {
                name:'多维数据数组对象从大到小排序', // 函数代表名
                funcName: '检查传入数组中对象,并根据指定数字属性进行从大到小排序', // 函数名字
                function: ARRAYSORTONJECT, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要排序的数组', // 第一个参数代表含义
                    },
                    {
                        text:'需要排序的对象指定值', // 第二个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[{name:'xx',age:19},{name:'ss',age:16},{name:'ww',age:12}
                        ,{name:'ee',age:17},{name:'qq',age:14},{name:'uu',age:22}],// 传入函数中的值
                        text:`[{name:'xx',age:19},{name:'ss',age:16},{name:'ww',age:12}
                        ,{name:'ee',age:17},{name:'qq',age:14},{name:'uu',age:22}]`, // 展示页面所用值
                    },
                    {
                        value:'age',// 传入函数中的值
                        text:'age', // 展示页面所用值
                    },
                ],
                
            },
            {
                name:'多维数据数组对象从小到大排序', // 函数代表名
                funcName: '检查传入数组中对象,并根据指定数字属性进行从小到大排序', // 函数名字
                function: ARRAYSORTONJECTTWO, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要排序的数组', // 第一个参数代表含义
                    },
                    {
                        text:'需要排序的对象指定值', // 第二个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[{name:'qq',age:19},{name:'ss',age:56},{name:'ww',age:12}
                        ,{name:'ii',age:17},{name:'qq',age:34},{name:'uu',age:22}],// 传入函数中的值
                        text:`[{name:'qq',age:19},{name:'ss',age:56},{name:'ww',age:12}
                        ,{name:'ii',age:17},{name:'qq',age:34},{name:'uu',age:22}]`, // 展示页面所用值
                    },
                    {
                        value:'age',// 传入函数中的值
                        text:'age', // 展示页面所用值
                    },
                ],
                
            },
            {
                name:'多维数据对象转为数组', // 函数代表名
                funcName: '检查传入对象,并进行转换为数组', // 函数名字
                function: OBJECTTOARRY, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的对象', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:{name:'xx',age:12,address:'china'},// 传入函数中的值
                        text:"{name:'xx',age:12,address:'china'}", // 展示页面所用值
                    }
                ],
            },
            {
                name:'多维数据获取对象指定值', // 函数代表名
                funcName: '检查传入对象,获取需要的指定key值', // 函数名字
                function: OBJECTGETKEY, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要操作的对象', // 第一个参数代表含义
                    },
                    {
                        text:'获取数组中指定的key值'
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:{name:'xx',age:12,address:'china',time:'2019-10-10'},// 传入函数中的值
                        text:"{name:'xx',age:12,address:'china',time:'2019-10-10'}", // 展示页面所用值
                    },
                    {
                        value:['name','address'],
                        text: "['name','address']"
                    }
                ],
            },
            {
                name:'多维数据子数组排序', // 函数代表名
                funcName: '传入多维数组,并对子数组中数值排序进行,非子数组则会跳过', // 函数名字
                function: ARRAYMANYSORT, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要排序的多维数组', // 第一个参数代表含义
                    },
                    {
                        text:'是否从大到小排序,默认从大到小'
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    
                    {
                        value:[[43,12,56,26,47],[21,76,74,23,63],'我不是数组',[85,74,12,53,23]],
                        text: "[[43,12,56,26,47],[21,76,74,23,63],'我不是数组',[85,74,12,53,23]]"
                    },
                    {
                        value:false,
                        text:'false'
                    }
                ],
            },
            {
                name:'多维数据子数组中对象拆分为数组', // 函数代表名
                funcName: '传入多维数组,并对子数组中对象进行拆分成数组,非子数组则会跳过', // 函数名字
                function: ARRAYSPLITOBJECT, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要拆分的多维数组', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    
                    {
                        value:[[{age:21,name:'sx',address:'chind'},{post:'职位',title:'标题'}],[{name1:'as',age1:43,address:'china'},{post:'职位',title:'标题'}]],
                        text: "[[{age:21,name:'sx',address:'chind'},{post:'职位',title:'标题'}],[{name1:'as',age1:43,address:'china'},{post:'职位',title:'标题'}]]"
                    }
                ],
            },
        ]
    },
    {
        name:'数据库函数', // 系列函数名称
        images: Database,
        pitchImages: Database2,
        children:[
            {
                name:'数据库函数子函数', // 函数代表名
                funcName: 'sql', // 函数名字
                function: sql, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:'', // 传入函数中的值
                        text: '', // 展示页面所用值
                    }
                ]
            }
        ]
    },
    {
        name:'日期和时间函数', // 系列函数名称
        images: DateImg,
        pitchImages: DateImg2,
        children:[
            {
                name:'日期差值计算', // 函数代表名
                funcName: '将传入2个时间戳进行计算,返回2者时间戳差值', // 函数名字
                function: CONTRASTTIME, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入计算时间戳', // 第一个参数代表含义
                    },
                    {
                        text:'传入计算时间戳', // 第二个参数代表含义
                    },
                    {
                        text:'是否需要将时间差值进行转换(true或false)',
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:1576122231269,// 传入函数中的值
                        text:'1576122231269', // 展示页面所用值
                    },
                    {
                        value:1576111231269,// 传入函数中的值
                        text:'1576121231269', // 展示页面所用值
                    },
                    {
                        value:true,
                        text:'true'
                    }
                ],
            },
            {
                name:'日期年月日格式化', // 函数代表名
                funcName: '将传入的时间戳格式化为年月日', // 函数名字
                function: DATEGETYEAR, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入需要格式化时间戳', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:1576122231269,// 传入函数中的值
                        text:'1576122231269', // 展示页面所用值
                    }
                ],
            },
            {
                name:'日期月日格式化', // 函数代表名
                funcName: '将传入的时间戳格式化为月日', // 函数名字
                function: DATAGETMONTH, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入需要格式化时间戳', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:1576122231269,// 传入函数中的值
                        text:'1576122231269', // 展示页面所用值
                    }
                ],
            },
            {
                name:'日期日格式化', // 函数代表名
                funcName: '将传入的时间戳格式化为日', // 函数名字
                function: DATAGETDAY, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入需要格式化时间戳', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:1576122231269,// 传入函数中的值
                        text:'1576122231269', // 展示页面所用值
                    }
                ],
            },
            {
                name:'日期时间格式化', // 函数代表名
                funcName: '将传入的时间戳格式化为时间', // 函数名字
                function: DATAGETTIME, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入需要格式化时间戳', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:1576122231269,// 传入函数中的值
                        text:'1576122231269', // 展示页面所用值
                    }
                ],
            },
            {
                name:'日期自定义格式化', // 函数代表名
                funcName: '将传入的时间戳按照自定义格式化为时间格式', // 函数名字
                function: DATAGETCUSTOM, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入需要格式化时间戳', // 第一个参数代表含义
                    },
                    {
                        text:'传入的时间格式化格式'
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:1576122231269,// 传入函数中的值
                        text:'1576122231269', // 展示页面所用值
                    },
                    {
                        value:'YYYY-MM-DD hh:mm:ss',
                        text:'YYYY-MM-DD hh:mm:ss',
                    }
                ],
            },
        ]
    },
    {
        name:'财务函数', // 系列函数名称
        images: Finance,
        pitchImages: Finance2,
        children:[
            {
                name:'财务自动求和', // 函数代表名
                funcName: '将传入2个数值进行相加,返回相加后总数', // 函数名字
                function: AUTOSUMMATION, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入被加值', // 第一个参数代表含义
                    },
                    {
                        text:'传入累加值', // 第二个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:23,// 传入函数中的值
                        text:'23', // 展示页面所用值
                    },
                    {
                        value:85,// 传入函数中的值
                        text:'85', // 展示页面所用值
                    },
                ],
                
            },
            {
                name:'财务自动求平均值', // 函数代表名
                funcName: '将传入的数字数组集合累加并进行平均值求值', // 函数名字
                function: AUTOMEAN, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入所有需要求平均值的数组集合', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[8,9,6,8,7,16], // 传入函数中的值
                        text: '[8,9,6,8,7,16]', // 展示页面所用值
                    }
                ]
            },
            {
                name:'财务自动获取最大值', // 函数代表名
                funcName: '将传入的数字数组集合获取最大值', // 函数名字
                function: AUTOMAX, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入所有需要求获取最大值的数组集合', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[8,9,6,8,7,16], // 传入函数中的值
                        text: '[8,9,6,8,7,16]', // 展示页面所用值
                    }
                ]
            },
            {
                name:'财务自动获取最小值', // 函数代表名
                funcName: '将传入的数字数组集合获取最小值', // 函数名字
                function: AUTOMIN, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入所有需要求获取最小值的数组集合', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[8,9,6,8,7,16], // 传入函数中的值
                        text: '[8,9,6,8,7,16]', // 展示页面所用值
                    }
                ]
            },
        ]
    },
    {
        name:'信息函数', // 系列函数名称
        images: MessageImg,
        pitchImages: MessageImg2,
        children:[
            {
                name:'信息类型判断', // 函数代表名
                funcName: '将传入的数据判断类型并返回', // 函数名字
                function: TYPEOFDATA, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入一个数据,对传入数据进行判断', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:['测试'], // 传入函数中的值
                        text: '["测试"]', // 展示页面所用值
                    }
                ]
            },
            {
                name:'信息提示', // 函数代表名
                funcName: '将传入的提示内容添加到提示框展示', // 函数名字
                function: TOASTMESSAGE, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要提示用户的信息', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:'测试信息', // 传入函数中的值
                        text: '测试信息', // 展示页面所用值
                    }
                ]
            },
            {
                name:'信息NaN判断', // 函数代表名
                funcName: '将传入的数据是否是NaN', // 函数名字
                function: TYPEOFNAN, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入的需要判断数据', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:NaN, // 传入函数中的值
                        text: 'NaN', // 展示页面所用值
                    }
                ]
            },
        ]
    },
    {
        name:'逻辑函数', // 系列函数名称
        images: Logic,
        pitchImages: Logic2,
        children:[
            {
                name:'逻辑判断数组是否存在空数值', // 函数代表名
                funcName: '检查传入数组所有值是否存在值,存在控制返回true', // 函数名字
                function: LOGICARRAY, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要检查的数组', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[56,'23','236',undefined,null], // 传入函数中的值
                        text: "[56,'23','236',undefined,null]", // 展示页面所用值
                    }
                ]
            },
            {
                name:'逻辑判断文本内容对比', // 函数代表名
                funcName: '对比传入的2个字符串是否相同', // 函数名字
                function: STRINGISSAME, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要对比的字符串', // 第一个参数代表含义
                    },
                    {
                        text:'需要对比的字符串', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: '你好,world', // 传入函数中的值
                        text: '你好,world', // 展示页面所用值
                    },
                    {
                        value: '你好世界', // 传入函数中的值
                        text: '你好世界', // 展示页面所用值
                    }
                ]
            },
            {
                name:'逻辑判断文本对比查询', // 函数代表名
                funcName: '对比传入的2个字符串对比,查询后面传入值是否存在于第一个参数中', // 函数名字
                function: STRINGISHAVE, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要对比的字符串', // 第一个参数代表含义
                    },
                    {
                        text:'需要对比的字符串', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: '你好,world', // 传入函数中的值
                        text: '你好,world', // 展示页面所用值
                    },
                    {
                        value: '好', // 传入函数中的值
                        text: '好', // 展示页面所用值
                    }
                ]
            },
            {
                name:'逻辑筛选数组指定值', // 函数代表名
                funcName: '检查数值是否存在指定值,存在则返回', // 函数名字
                function: LOGICARRAYFILTER, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要检查的数组', // 第一个参数代表含义
                    },
                    {
                        text:'指定值', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: ['你好','世界','嗯'], // 传入函数中的值
                        text: "['你好','世界','嗯']", // 展示页面所用值
                    },
                    {
                        value: '世界', // 传入函数中的值
                        text: '世界', // 展示页面所用值
                    }
                ]
            },
        ]
    },
    {
        name:'查找和引用函数', // 系列函数名称
        images: Find,
        pitchImages: Find2,
        children:[
            {
                name:'查找并替换字段', // 函数代表名
                funcName: '修改字符串中匹配的第一个字段', // 函数名字
                function: FINDSTRRPLACE, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入需要查询的字符串', // 第一个参数代表含义
                    },
                    {
                        text: '传入需要查询的字段',
                    },
                    {
                        text: '传入需要更换查询的字段',
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:'你好,世界', // 传入函数中的值
                        text: '你好,世界', // 展示页面所用值
                    },
                    {
                        value:'世界',
                        text:'世界',
                    },
                    {
                        value:'美丽世界',
                        text:'美丽世界'
                    }
                ]
            },
            {
                name:'查找数组内容', // 函数代表名
                funcName: '查找出数组中匹配的第一个数值', // 函数名字
                function: FINDARRAYNUM, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入需要查询的数组', // 第一个参数代表含义
                    },
                    {
                        text: '传入需要查询的内容',
                    },
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[2,3,5,2,21], // 传入函数中的值
                        text: '[2,3,5,2,21]', // 展示页面所用值
                    },
                    {
                        value:21,
                        text:'21',
                    }
                ]
            },
        ]
    },
    {
        name:'数学和三角函数', // 系列函数名称
        images: MathImg,
        pitchImages: MathImg2,
        children:[
            {
                name:'数学自动求和', // 函数代表名
                funcName: '将传入2个数值进行相加,返回相加后总数', // 函数名字
                function: AUTOSUMMATION, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入被加值', // 第一个参数代表含义
                    },
                    {
                        text:'传入累加值', // 第二个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:23,// 传入函数中的值
                        text:'23', // 展示页面所用值
                    },
                    {
                        value:85,// 传入函数中的值
                        text:'85', // 展示页面所用值
                    },
                ],
                
            },
            {
                name:'数学自动求平均值', // 函数代表名
                funcName: '将传入的数字数组集合累加并进行平均值求值', // 函数名字
                function: AUTOMEAN, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入所有需要求平均值的数组集合', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[8,9,6,8,7,16], // 传入函数中的值
                        text: '[8,9,6,8,7,16]', // 展示页面所用值
                    }
                ]
            },
            {
                name:'数学自动获取最大值', // 函数代表名
                funcName: '将传入的数字数组集合获取最大值', // 函数名字
                function: AUTOMAX, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入所有需要求获取最大值的数组集合', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[8,9,6,8,7,16], // 传入函数中的值
                        text: '[8,9,6,8,7,16]', // 展示页面所用值
                    }
                ]
            },
            {
                name:'数学自动获取最小值', // 函数代表名
                funcName: '将传入的数字数组集合获取最小值', // 函数名字
                function: AUTOMIN, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入所有需要求获取最小值的数组集合', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[8,9,6,8,7,16], // 传入函数中的值
                        text: '[8,9,6,8,7,16]', // 展示页面所用值
                    }
                ]
            },
        ]
    },
    {
        name:'统计函数', // 系列函数名称
        images: Statistics,
        pitchImages: Statistics2,
        children:[
            {
                name:'统计数组总值', // 函数代表名
                funcName: '将传入的数组值,进行累加返回累加总数,如果存在非数字会跳过计算', // 函数名字
                function: ARRAYADDNUM, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入需要进行累积的数组', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[8,9,6,8,7,'测试',16], // 传入函数中的值
                        text: '[8,9,6,8,7,"测试",16]', // 展示页面所用值
                    }
                ]
            },
            {
                name:'统计数组中对象某一值总数', // 函数代表名
                funcName: '将传入的数组值,进行累加返回累加总数,如果存在非数字会跳过计算', // 函数名字
                function: ARRAYOBJECTADD, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入需要进行累积的数组', // 第一个参数代表含义
                    },
                    {
                        text: '指定需要累积的对象key值'
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[{num:3},{num:33},{num:63},{num:43},{num:23},{num:"98w"},{num:13}], // 传入函数中的值
                        text: '[{num:3},{num:33},{num:63},{num:43},{num:23},{num:"98w"},{num:13}]', // 展示页面所用值
                    },
                    {
                        value:'num',
                        text:'num',
                    }
                ]
            },
            {
                name:'统计用户输入长度', // 函数代表名
                funcName: '统计用户总共输入的长度并返回', // 函数名字
                function: STRINGLEHGTH, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要统计的内容长度', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:'我是被测试内容', // 传入函数中的值
                        text: '我是被测试内容', // 展示页面所用值
                    }
                ]
            },
            {
                name:'统计自动求和', // 函数代表名
                funcName: '将传入2个数值进行相加,返回相加后总数', // 函数名字
                function: AUTOSUMMATION, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入被加值', // 第一个参数代表含义
                    },
                    {
                        text:'传入累加值', // 第二个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:23,// 传入函数中的值
                        text:'23', // 展示页面所用值
                    },
                    {
                        value:85,// 传入函数中的值
                        text:'85', // 展示页面所用值
                    },
                ],
                
            },
            {
                name:'统计自动求平均值', // 函数代表名
                funcName: '将传入的数字数组集合累加并进行平均值求值', // 函数名字
                function: AUTOMEAN, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入所有需要求平均值的数组集合', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[8,9,6,8,7,16], // 传入函数中的值
                        text: '[8,9,6,8,7,16]', // 展示页面所用值
                    }
                ]
            },
            {
                name:'统计自动获取最大值', // 函数代表名
                funcName: '将传入的数字数组集合获取最大值', // 函数名字
                function: AUTOMAX, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入所有需要求获取最大值的数组集合', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[8,9,6,8,7,16], // 传入函数中的值
                        text: '[8,9,6,8,7,16]', // 展示页面所用值
                    }
                ]
            },
            {
                name:'统计自动获取最小值', // 函数代表名
                funcName: '将传入的数字数组集合获取最小值', // 函数名字
                function: AUTOMIN, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'传入所有需要求获取最小值的数组集合', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:[8,9,6,8,7,16], // 传入函数中的值
                        text: '[8,9,6,8,7,16]', // 展示页面所用值
                    }
                ]
            },
        ]
    },
    {
        name:'文本函数', // 系列函数名称
        images: TextImg,
        pitchImages: TextImg2,
        children:[
            {
                name:'文本HTML标签转译', // 函数代表名
                funcName: '将文本域输入的HTML标签转移', // 函数名字
                function: TRANSLATIONSTRING, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要进行转移的文本输入', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:'<script>alert("233")</script>', // 传入函数中的值
                        text: '<script>alert("233")</script>', // 展示页面所用值
                    }
                ]
            },
            {
                name:'文本HTML标签反向转译', // 函数代表名
                funcName: '将文本域输入的已转译HTML标签反向转译', // 函数名字
                function: TRANSLATIONSTRINGTWO, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要进行反向转译的文本输入', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:'&lt;script&gt;alert(&quto;233&quto;)&lt;&#x2F;script&gt;', // 传入函数中的值
                        text: '&lt;script&gt;alert(&quto;233&quto;)&lt;&#x2F;script&gt;', // 展示页面所用值
                    }
                ]
            },
            {
                name:'文本数组内容拼接', // 函数代表名
                funcName: '将数组内容进行拼接,会跳过拼接对象', // 函数名字
                function: TEXTCONCAT, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要拼接的数组内容', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value:['你好',{num:1},'世界'], // 传入函数中的值
                        text: "['你好',{num:1},'世界']", // 展示页面所用值
                    }
                ]
            },
            {
                name:'文本内容对比', // 函数代表名
                funcName: '对比传入的2个字符串是否相同', // 函数名字
                function: STRINGISSAME, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要对比的字符串', // 第一个参数代表含义
                    },
                    {
                        text:'需要对比的字符串', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: '你好,世界', // 传入函数中的值
                        text: '你好,世界', // 展示页面所用值
                    },
                    {
                        value: '你好世界', // 传入函数中的值
                        text: '你好世界', // 展示页面所用值
                    }
                ]
            },
            {
                name:'文本对比查询', // 函数代表名
                funcName: '对比传入的2个字符串对比,查询后面传入值是否存在于第一个参数中', // 函数名字
                function: STRINGISHAVE, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要对比的字符串', // 第一个参数代表含义
                    },
                    {
                        text:'需要对比的字符串', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: '你好,世界', // 传入函数中的值
                        text: '你好,世界', // 展示页面所用值
                    },
                    {
                        value: '好', // 传入函数中的值
                        text: '好', // 展示页面所用值
                    }
                ]
            },
            {
                name:'文本转换为驼峰写法', // 函数代表名
                funcName: '将文本英文转为驼峰写法', // 函数名字
                function: STRINGCAMELCASE, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的字符串', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: '你好,hello world,世界', // 传入函数中的值
                        text: '你好,hello world,世界', // 展示页面所用值
                    }
                ]
            },
            {
                name:'文本校验', // 函数代表名
                funcName: '校验传入文本是否按照规定字符结尾', // 函数名字
                function: STRINGVERIFY, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要校验的字符串', // 第一个参数代表含义
                    },
                    {
                        text:'需要校验的字符规则', // 第一个参数代表含义
                    },
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: '你好,hello world,世界', // 传入函数中的值
                        text: '你好,hello world,世界', // 展示页面所用值
                    },
                    {
                        value: '世界', // 传入函数中的值
                        text: '世界', // 展示页面所用值
                    },
                ]
            },
            {
                name: '文本拆分为集合', // 函数代表名
                funcName: '拆分字符串内容成数组', // 函数名字
                function: STRINGWORDS, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要拆分的字段', // 第一个参数代表含义
                    },
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: '你好,hello world,世界', // 传入函数中的值
                        text: '你好,hello world,世界', // 展示页面所用值
                    }
                ]
            },
        ]
    },
    {
        name:'工程函数', // 系列函数名称
        images: Project,
        pitchImages: Project2,
        children:[
            {
                name:'工程十进制转八进制', // 函数代表名
                funcName: '获得十进制参数并转换为八进制返回', // 函数名字
                function: TENSCALETOEIGHT, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 580, // 传入函数中的值
                        text: '580', // 展示页面所用值
                    },
                ]
            },
            {
                name:'工程十进制转十六进制', // 函数代表名
                funcName: '获得十进制参数并转换为十六进制返回', // 函数名字
                function: TENSCALETOSIXTEEN, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 580, // 传入函数中的值
                        text: '580', // 展示页面所用值
                    },
                ]
            },
            {
                name:'工程十进制转二进制', // 函数代表名
                funcName: '获得十进制参数并转换为二进制返回', // 函数名字
                function: TENSCALETOTWO, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 580, // 传入函数中的值
                        text: '580', // 展示页面所用值
                    },
                ]
            },
            {
                name:'工程十进制自定义转化', // 函数代表名
                funcName: '获得十进制参数并转换为自定义转化返回', // 函数名字
                function: TENSCALETOMANY, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    },
                    {
                        text:'自定义的进制转换'
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 580, // 传入函数中的值
                        text: '580', // 展示页面所用值
                    },
                    {
                        value: 8,
                        text:'8'
                    }
                ]
            },
            {
                name:'工程八进制到十进制转换', // 函数代表名
                funcName: '获得八进制参数并转换为十进制返回', // 函数名字
                function: EIGHTSCALETOTEN, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 1104, // 传入函数中的值
                        text: '1104', // 展示页面所用值
                    }
                ]
            },
            {
                name:'工程八进制到十六进制转换', // 函数代表名
                funcName: '获得八进制参数并转换为十六进制返回', // 函数名字
                function: EIGHTSCALETOSIXTEEN, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 1104, // 传入函数中的值
                        text: '1104', // 展示页面所用值
                    }
                ]
            },
            {
                name:'工程八进制到二进制转换', // 函数代表名
                funcName: '获得八进制参数并转换为二进制返回', // 函数名字
                function: EIGHTSCALETOTWO, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 1104, // 传入函数中的值
                        text: '1104', // 展示页面所用值
                    }
                ]
            },
            {
                name:'工程八进制到自定义进制转换', // 函数代表名
                funcName: '获得八进制参数并转换为自定义返回', // 函数名字
                function: EIGHTSCALETOMANY, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    },
                    {
                        text:'自定义的进制转换'
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 1104, // 传入函数中的值
                        text: '1104', // 展示页面所用值
                    },
                    {
                        value:10,
                        text:'10'
                    }
                ]
            },
            {
                name:'工程十六进制到十进制转换', // 函数代表名
                funcName: '获得十六进制参数并转换为十进制返回', // 函数名字
                function: SIXTEENSCALETOTEN, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 244, // 传入函数中的值
                        text: '244', // 展示页面所用值
                    }
                ]
            },
            {
                name:'工程十六进制到二进制转换', // 函数代表名
                funcName: '获得十六进制参数并转换为二进制返回', // 函数名字
                function: SIXTEENSCALETOTWO, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 244, // 传入函数中的值
                        text: '244', // 展示页面所用值
                    }
                ]
            },
            {
                name:'工程十六进制到八进制转换', // 函数代表名
                funcName: '获得十六进制参数并转换为八进制返回', // 函数名字
                function: SIXTEENSCALETOEIGHT, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 244, // 传入函数中的值
                        text: '244', // 展示页面所用值
                    }
                ]
            },
            {
                name:'工程十六进制到自定义进制转换', // 函数代表名
                funcName: '获得十六进制参数并转换为自定义返回', // 函数名字
                function: SIXTEENSCALETOMANY, // 当前函数
                params: [ // 函数所需要传入值内容 为空为不传值
                    {
                        text:'需要转换的数字', // 第一个参数代表含义
                    },
                    {
                        text:'自定义的进制转换'
                    }
                ],
                demo: [ // 展示给用户看的案例传入值
                    {
                        value: 244, // 传入函数中的值
                        text: '244', // 展示页面所用值
                    },
                    {
                        value:10,
                        text:'10'
                    }
                ]
            },
        ]
    },
]
/**
 * 公式选择数组
 */
const tabList = [
    // {
    //     name:'柱形图',
    //     key:'1',
    //     images: Column,
    //     pitchImages: Column2,
    //     children:[
    //         // 格式参考 
    //         // {
    //         //     name: '', // 函数名字
    //         //     funcName: '', // 函数介绍
    //         //     function: ''. // 函数
    //         // }
    //     ],
    //     isPitch:false, // 是否选中
    //     isShowList: false, // 是否自动展开子表单
    // },
    // {
    //     name:'饼图',
    //     key:'2',
    //     images:PieImg,
    //     pitchImages: PieImg2,
    //     children:[],
    //     isPitch:false,
    //     isShowList: false,
    // },
    // {
    //     name: '雷达图',
    //     key:'3',
    //     images: Radar,
    //     pitchImages: Radar2,
    //     children:[],
    //     isPitch:false,
    //     isShowList: false,
    // },
    // {
    //     name: '气泡图',
    //     key:'4',
    //     images: Bubble,
    //     pitchImages: Bubble2,
    //     children:[],
    //     isPitch:false,
    //     isShowList: false,
    // },
    // {
    //     name: '散点图',
    //     key:'5',
    //     images: Splashes,
    //     pitchImages: Splashes2,
    //     children:[],
    //     isPitch:false,
    //     isShowList: false,
    // },
    // {
    //     name: '树状图',
    //     key: '6',
    //     images: Dendrogram,
    //     pitchImages: Dendrogram2,
    //     children:[],
    //     isPitch:false,
    //     isShowList: false,
    // },
    // {
    //     name: '箱型图',
    //     key: '7',
    //     images: Box,
    //     pitchImages: Box2,
    //     children:[],
    //     isPitch:false,
    //     isShowList: false,
    // },
    // {
    //     name: '旭日图',
    //     key: '8',
    //     images: Rising,
    //     pitchImages: Rising2,
    //     children:[],
    //     isPitch:false,
    //     isShowList: false,
    // },
    // {
    //     name: '折线图',
    //     key: '9',
    //     images: Line,
    //     pitchImages: Line2,
    //     children:[],
    //     isPitch:false,
    //     isShowList: false,
    // },
    // {
    //     name: '直方图',
    //     key:'10',
    //     images: Straight,
    //     pitchImages: Straight2,
    //     children:[],
    //     isPitch:false,
    //     isShowList: false,
    // }
]
/**
 * List 在此做格式化操作并添加入tabList导出,
 * 属于List数组中函数新增应新增到List中,此处会自动添加进去
 * 属于tabList数组函数新增应新增到tabList中
 */
List.map( (item,index) => {
    tabList.push({
        name:item.name,
        key:item.name+index,
        images: item.images,
        pitchImages: item.pitchImages,
        isPitch:false,
        isShowList: false,
        children:item.children.map((arr,i) => {
            return {
                name: arr.name,
                funcName: arr.funcName,
                function: arr.function
            }
        })
    })
})
export const formulaList = tabList
/**
 * 数据库函数系列
 * @param {*} params 
 */
export function sql() {
    
}
/**
 * 基础计算函数
 * 自动求和
 * @param {传入被加值} num 
 * @param {传入累加值} num1 
 */
export function AUTOSUMMATION(num,num1) {
    num=+num
    num1=+num1
    return num+num1
}
/**
 * 基础计算函数
 * 自动求平均值
 * @param {传入需要累加的数组,里面为数字} List 
 */
export function AUTOMEAN(List) {
    let num = 0; // 初始值
    let mean = 0; // 平均值
    if(isArray(List)){
        List.map(item => {
            if(typeof item == 'number'||typeof item == 'string'){
                num +=item
            } else {
                console.log('这不是一个数字')
                return 
            }
        })
        if(isNaN(num)){
            console.log('传入值错误,请检查')
        } else {
            mean = num/List.length
            return mean
        }
    } else {
        console.log('这不是数组')
        return
    }
}
/**
 * 基础计算函数
 * 获取最大值
 * @param {传入需要累加的数组,获取数组最大值} List 
 */
export function AUTOMAX(List) {
    return Math.max.apply(null,List);
}
/**
 * 基础计算函数
 * 获取最大值
 * @param {传入需要累加的数组,获取数组最小值} List 
 */
export function AUTOMIN(List) {
    return Math.min.apply(null,List);
}
/**
 * 查找引用函数
 * 修改字符串中匹配的第一个字段
 * @param {传入需要查询的字符串} str 
 * @param {传入需要查询的字段} str2 
 * @param {传入需要更换的字段} str32
 */
export function FINDSTRRPLACE(str,str2,str3) {
    if(typeof str == 'string'&&typeof str2 == 'string'&&typeof str3 == 'string'){
        str=str.replace(str2,str3)
        return str
    } else {
        console.log('这不是个字符串')
    }
}
/**
 * 查找引用函数
 * 查找出数组中匹配的第一个数值
 * @param {传入需要查询的数组} arr
 * @param {传入需要查询的内容} data
 */
export function FINDARRAYNUM(arr,data) {
    if(isArray(arr)){
        if(typeof arr[0] == 'object'){
            let index = arr.findIndex(arr,data)
            if(index == -1){
                return '数组不存在查询值'
            }else{
                return arr[index]
            }
        }
        let index = arr.indexOf(data)
        if(index == -1){
            return '数组不存在查询值'
        }else{
            return arr[index]
        }
    }else{
        return '传入值不是数组'
    }
}
/**
 * 兼容性函数
 * 合并2个传入的数组集合
 * @param {传入需要合并的数组} arr
 * @param {传入需要合并的数组} arr1
 */
export function MERGEARRAY(arr,arr1) {
    if(isArray(arr)&&isArray(arr1)){
        const list = [...arr,...arr1]
        return list
    }else{
        return '传入值不是数组'
    }
}
/**
 * 兼容性函数
 * 根据传入数组进行拆分成多维数组
 * @param {传入需要拆分的数组} arr
 * @param {传入需要拆分成长度的数值} num
 */
export function SPLITARRAY(arr,num) {
    if(isArray(arr)){
        let list = chunk(arr,num)
        return list
    }else {
        return '传入值不是数组'
    }
}
/**
 * 兼容性函数
 * 根据传入数组和切片长度,去除对应长度的数组
 * @param {传入需要拆分的数组} arr
 * @param {传入需要拆分成长度的数值} num
 */
export function REMOVEARRAYDROP(arr,num) {
    if(isArray(arr)){
        let list = drop(arr,num)
        return list
    }else {
        return '传入值不是数组'
    }
}
/**
 * 日期和时间函数
 * 根据传入的2个时间戳进行对比,返回时间差值
 * @param {传入需要对比的时间戳} time
 * @param {传入需要对比的时间戳} time1
 * @param {是否需要将时间差值进行转换} isFormat
 */
export function CONTRASTTIME(time,time1,isFormat) {
    if(typeof time1 == 'number'&&typeof time=='number'){
        if(time1>time){
            let data = time1-time
            if(isFormat){
                return getTimeMonth(data)
            }else{
                return data
            }
        } else if(time1<time){
            let data = time-time1
            if(isFormat){
                return getTimeMonth(data)
            }else{
                return data
            }
        }
    } else {
        return '传入值不正确'
    }
}
/**
 * 时间戳格式化函数
 */
export function getTimeMonth(time) {
    if(time<=60000){ // 低于1分钟
        return '低于一分钟'
    } else if( 60000<=time&&time<3600000) { // 低于1小时 统计分钟数
        return moment(time).format('mm')+'分钟'
    } else if( 3600000<=time&&time<86400000 ){ // 高于一小时,低于一天
        return moment(time).format('hh:mm:ss')
    } else if(86400000<=time&&time<2592000000){ // 大于一天小于一个月
        return moment(time).format('DD天hh:mm:ss')
    }else if(2592000000<time){ // 大于一个月
        return moment(time).format('MM月DD天 hh:mm:ss')
    }
}
/**
 * 日期和时间函数
 * 将传入的时间戳格式化为年月日
 * @param {传入的时间戳} time
 */
export function DATEGETYEAR(time) {
    let data = moment(time).format('YYYY-MM-DD')
    return data
}
/**
 * 日期和时间函数
 * 将传入的时间戳格式化为月日
 * @param {传入的时间戳} time
 */
export function DATAGETMONTH(time) {
    let data = moment(time).format('MM-DD')
    return data
}
/**
 * 日期和时间函数
 * 将传入的时间戳格式化为日
 * @param {传入的时间戳} time
 */
export function DATAGETDAY(time) {
    let data = moment(time).format('DD')
    return data
}
/**
 * 日期和时间函数
 * 将传入的时间戳格式化为时间格式
 * @param {传入的时间戳} time
 */
export function DATAGETTIME(time) {
    let data = moment(time).format('hh:mm:ss')
    return data
}
/**
 * 日期和时间函数
 * 将传入的时间戳按照自定义格式化为时间格式
 * @param {传入的时间戳} time
 * @param {传入的时间格式化格式} str
 */
export function DATAGETCUSTOM(time,str) {
    let data = moment(time).format(str)
    return data
}
/**
 * 信息函数
 * 判断传入值的类型并返回
 * @param {需要判断类型的数据} data
 */
export function TYPEOFDATA(data) {
    if(typeof data == 'object'){
        if(isArray(data)){
            return 'array'
        } else {
            return 'object'
        }
    } else {
        return typeof data
    }
}
/**
 * 信息函数
 * 发起弹框提示用户信息
 * @param {需要提示用户的信息} str
 */
export function TOASTMESSAGE(str) {
    let width = document.documentElement.clientWidth || document.body.clientWidth;
    if(width<1200){
        showToast(str)
    } else {
        openToast('info','提示',str)
    }
    return ''
}
/**
 * 信息函数
 * 判断传入值是否为NAN
 * @param {传入的需要判断数据} str
 */
export function TYPEOFNAN(str) {
    if (typeof str == 'string') {
        try {
            JSON.parse(str);
            if(typeof JSON.parse(str) === 'number'){
            return false;
        }
            return true;
        } catch (e) {
            return false;
        }
    }
}
/**
 * 统计函数
 * 将传入的数组值,进行累加返回累加总数,如果存在非数字会跳过计算
 * @param {传入的需要累加的数组} ary
 */
export function ARRAYADDNUM(ary) {
    if(isArray(ary)){
        let sum = 0;
        ary.map(item => {
            if(isNaN(+item)){
                return
            }
            sum+=item
        })
        return sum
    }else {
        return '传入值非数组'
    }
}
/**
 * 统计函数
 * 将传入的为对象型数组进行指定属性统一累积
 * @param {传入的需要累加的数组} ary
 * @param {指定需要累积的对象key值} str
 */
export function ARRAYOBJECTADD(ary,str) {
    if(isArray(ary)){
        let sum = 0;
        ary.map(item => {
            if(isNaN(+item[str])){
                return
            }
            sum+=item[str]
        })
        return sum
    }else {
        return '传入值非数组'
    }
}
/**
 * 统计函数
 * 统计传入的字符串总共输入的长度
 * @param {需要统计的字符串长度} str
 */
export function STRINGLEHGTH(str) {
    return str.length
}
/**
 * 文本函数
 * 将文本域输入的HTML标签转译
 * @param {需要进行转移的文本输入} str
 */
export function TRANSLATIONSTRING(str) {
    str = str.replace(/&/g, '&amp;')
    str = str.replace(/</g, '&lt;')
    str = str.replace(/>/g, '&gt;')
    str = str.replace(/"/g, '&quto;')
    str = str.replace(/'/g, '&#39;')
    str = str.replace(/`/g, '&#96;')
    str = str.replace(/\//g, '&#x2F;')
    str = str.replace(/ /g, "&nbsp;");
    return str
}
/**
 * 文本函数
 * 将文本域输入的已转译HTML标签反向转译
 * @param {需要进行反向转译的文本输入} str
 */
export function TRANSLATIONSTRINGTWO(str) {
    str = str.replace(/&amp;/g, '&')
    str = str.replace(/&lt;/g, '<')
    str = str.replace(/&gt;/g, '>')
    str = str.replace(/&quto;/g, '"')
    str = str.replace(/&#39;/g, "'")
    str = str.replace(/&#96;/g, '`')
    str = str.replace(/&#x2F;/g, '\/')
    str = str.replace(/&nbsp;/g, " ");
    return str
}
/**
 * 文本函数
 * 拆分字符串内容成数组
 * @param {需要拆分的字段} str 
 */
export function STRINGWORDS(str) {
    if(typeof str == 'string'){
        return words(str)
    } else {
        return '传入值应该为字符串'
    }
}
/**
 * 文本函数
 * 将数组中内容进行拼接返回一个完整字符串,无法拼接则会跳过
 * @param {需要拼接的数组内容} ary
 */
export function TEXTCONCAT(ary) {
    if(isArray(ary)){
        let str = ''
        ary.map(item => {
            if(typeof item == 'object'){
                return
            }else{
                str = `${str}`+`${item}`
            }
        })
        return str
    }else {
        return '传入值非数组'
    }
}
/**
 * 文本函数
 * 对比传入的2个字符串是否相同
 * @param {需要对比的字符串} str
 * @param {需要对比的字符串} str1
 */
export function STRINGISSAME(str,str1) {
    return str === str1
}
/**
 * 文本函数
 * 对比传入的2个字符串对比,查询后面传入值是否存在于第一个参数中
 * @param {需要对比的字符串} str
 * @param {需要对比的字符串} str1
 */
export function STRINGISHAVE(str,str1) {
    let res = str.indexOf(str1)
    if(res == -1){
        return false
    }else {
        return true
    }
}
/**
 * 文本函数
 * 将文本英文转为驼峰写法
 * @param {需要转换的字符串} str
 */
export function STRINGCAMELCASE(str) {
    if(typeof str == 'string'){
        return camelCase(str)
    } else {
        return '这不是个字符串'
    }
}
/**
 * 文本函数
 * 校验传入文本是否按照规定字符结尾
 * @param {需要校验的字符串} str
 * @param {需要校验的字符规则} str1
 */
export function STRINGVERIFY(str,str1) {
    if(typeof str == 'string'&&typeof str1 == 'string'){
        return endsWith(str,str1)
    }else {
        return '传入值不是字符串'
    }
}
/**
 * 工程函数
 * 十进制转换8进制
 * @param { 需要转换的十进制} num
 */
export function TENSCALETOEIGHT(num) {
    if(typeof num == 'number'){
        return parseInt(num).toString(8)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 工程函数
 * 十进制转换16进制
 * @param { 需要转换的十进制} num
 */
export function TENSCALETOSIXTEEN(num) {
    if(typeof num == 'number'){
        return parseInt(num).toString(16)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 工程函数
 * 十进制转换2进制
 * @param { 需要转换的十进制} num
 */
export function TENSCALETOTWO(num) {
    if(typeof num == 'number'){
        return parseInt(num).toString(2)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 工程函数
 * 自定义十进制转换
 * @param {需要转换的十进制} num
 * @param {自定义的进制转换} num1
 */
export function TENSCALETOMANY(num,num1) {
    if(typeof num == 'number'&&typeof num1 == 'number'){
        return parseInt(num).toString(num1)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 工程函数
 * 八进制到十进制转换
 * @param {需要转换的八进制} num
 */
export function EIGHTSCALETOTEN(num) {
    if(typeof num == 'number'){
        return parseInt(num,8)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 工程函数
 * 八进制到十六进制转换
 * @param {需要转换的八进制} num
 */
export function EIGHTSCALETOSIXTEEN(num) {
    if(typeof num == 'number'){
        return parseInt(num,8).toString(16)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 工程函数
 * 八进制到二进制转换
 * @param {需要转换的八进制} num 
 */
export function EIGHTSCALETOTWO(num) {
    if(typeof num == 'number'){
        return parseInt(num,8).toString(2)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 工程函数
 * 八进制到自定义机制转换
 * @param {需要转换的八进制} num 
 * @param {自定义的进制转换} num1
 */
export function EIGHTSCALETOMANY(num,num1) {
    if(typeof num == 'number'&&typeof num1 == 'number'){
        return parseInt(num,8).toString(num1)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 工程函数
 * 十六进制转二进制
 * @param {需要转换的十六进制} num 
 */
export function SIXTEENSCALETOTWO(num) {
    if(typeof num == 'number'){
        return parseInt(num,16).toString(2)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 工程函数
 * 十六进制转八进制
 * @param {需要转换的十六进制} num 
 */
export function SIXTEENSCALETOEIGHT(num) {
        if(typeof num == 'number'){
        return parseInt(num,16).toString(8)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 工程函数
 * 十六进制转十进制
 * @param {需要转换的十六进制} num
 */
export function SIXTEENSCALETOTEN(num) {
    if(typeof num == 'number'){
        return parseInt(num,16)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 工程函数
 * 十六进制转自定义进制
 * @param {需要转换的十六进制} num
 * @param {自定义的进制转换} num1
 */
export function SIXTEENSCALETOMANY(num,num1) {
    if(typeof num == 'number'&&typeof num1 == 'number'){
        return parseInt(num,16).toString(num1)
    }else{
        return '传入值不是数字'
    }
}
/**
 * 逻辑函数
 * 检查传入数组所有值是否存在值,存在控制返回true
 * @param {需要检查的数组} ary
 */
export function LOGICARRAY(ary) {
    if(isArray(ary)){
        let isHave = true
        ary.map(item => {
            if(!!item == false){
                isHave = false
            }
        })
        return isHave
    }else {
        return '传入值不是数组'
    }
}
/**
 * 逻辑函数
 * 检查数值是否存在指定值,存在则返回
 * @param {需要检查的数组} ary
 * @param {需要检查的指定值} res
 */
export function LOGICARRAYFILTER(ary,res) {
    if(isArray(ary)){
        let data;
        data = ary.filter(item => item==res)
        if(data.length>0){
            return data
        }else {
            return '不存在指定值'
        }
    }else {
        return '传入值不是数组'
    }
}
/**
 * 多维数据集函数
 * 检查传入数组中对象,并根据指定数字属性进行从大到小排序
 * @param {需要排序的数组} ary
 * @param {需要排序的对象指定值} name
 */
export function ARRAYSORTONJECT(ary,name) {
    function sortList(obj1,obj2){
        var a=obj1[name];
        var b=obj2[name];                                   
        if(a>b){    
            return -1
        }else if(a<b){    
            return 1
        }else{
            return 0
        }              
    };
    if(isArray(ary)){
        return ary.sort(sortList)
    }else {
        return '传入值不是数组'
    }
}
/**
 * 多维数据集函数
 * 检查传入数组中对象,并根据指定数字属性进行从小到大排序
 * @param {需要排序的数组} ary
 * @param {需要排序的对象指定值} name
 */
export function ARRAYSORTONJECTTWO(ary,name) {
    function sortList(obj1,obj2){
        var a=obj1[name];
        var b=obj2[name];                                  
        if(a<b){    
            return -1
        }else if(a>b){    
            return 1
        }else{
            return 0
        }              
    };
    if(isArray(ary)){
        return ary.sort(sortList)
    }else {
        return '传入值不是数组'
    }
}
/**
 * 多维数据集函数
 * 检查传入对象,并进行转换为数组
 * @param {需要转换的对象} obj
 */
export function OBJECTTOARRY(obj) {
    let arr = [];
    for (let i in obj) {
        let o = {};
        o[i] = obj[i];
        arr.push(o)
    }
    return arr
}
/**
 * 多维数据集函数
 * 检查传入对象,获取需要的指定key值
 * @param {需要操作的对象} obj
 * @param {获取数组中指定的key值} ary
 */
export function OBJECTGETKEY(obj,ary) {
    if(isArray(ary)){
        return  pick(obj,ary)
    }else{
        return '获取key值需传入数组'
    }
}
/**
 * 多维数据集函数
 * 传入多维数组,并对子数组中数值排序进行,非子数组则会跳过
 * @param {需要排序的多维数组} ary
 * @param {是否从大到小排序} isSort
 */
export function ARRAYMANYSORT(ary,isSort = true) {
    function sortList(a,b){
        if(isSort){
            if(a>b){    
                return -1
            }else if(a<b){    
                return 1
            }else{
                return 0
            } 
        } else {
            if(a<b){    
                return -1
            }else if(a>b){    
                return 1
            }else{
                return 0
            } 
        }
    };
    if(isArray(ary)){
        ary.map(item => {
            if(isArray(item)){
                return item.sort(sortList)
            } else {
                return
            }
        })
        return ary
    }else{
        return '传入值应为数组'
    }
}
/**
 * 多维数据集函数
 * 传入多维数组,并对子数组中对象进行拆分成数组,非子数组则会跳过
 * @param {需要拆分的多维数组} ary
 */
export function ARRAYSPLITOBJECT(ary) {
    if(isArray(ary)){
        let data = ary.map(item => {
            if(isArray(item)){
                let newAry = item.map(res => {
                    if(Object.prototype.toString.call(res) == '[object Object]'){
                        let arr = [];
                        for (let i in res) {
                            let o = {};
                            o[i] = res[i];
                            arr.push(o)
                        }
                        return arr
                    }
                    return res
                }) 
                return newAry
            } else {
                return item
            }
        })
        return data
    } else {
        return '应传入一个数组'
    }
}
export default List
